from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String

Iupac2Meme_V0_1_0 = CommandToolBuilder(tool="iupac2meme", base_command=["iupac2meme"], inputs=[ToolInput(tag="in_use_dna_iupac_alphabet", input_type=Boolean(optional=True), prefix="-dna", doc=InputDocumentation(doc="use DNA IUPAC alphabet")), ToolInput(tag="in_use_rna_iupac_alphabet", input_type=Boolean(optional=True), prefix="-rna", doc=InputDocumentation(doc="use RNA IUPAC alphabet")), ToolInput(tag="in_use_protein_iupac_alphabet", input_type=Boolean(optional=True), prefix="-protein", doc=InputDocumentation(doc="use protein IUPAC alphabet")), ToolInput(tag="in_alph", input_type=File(optional=True), prefix="-alph", doc=InputDocumentation(doc="file with alphabet definition;\ndefault: use DNA IUPAC alphabet")), ToolInput(tag="in_num_seqs", input_type=Int(optional=True), prefix="-numseqs", doc=InputDocumentation(doc="assume frequencies based on this many\nsequences; default: 20")), ToolInput(tag="in_bg", input_type=File(optional=True), prefix="-bg", doc=InputDocumentation(doc="file with background frequencies of letters;\ndefault: uniform background")), ToolInput(tag="in_pseudo", input_type=Int(optional=True), prefix="-pseudo", doc=InputDocumentation(doc="add <total pseudocounts> times letter\nbackground to each frequency; default: 0")), ToolInput(tag="in_output_logodds_pssm", input_type=Boolean(optional=True), prefix="-logodds", doc=InputDocumentation(doc="output the log-odds (PSSM) and frequency\n(PSPM) motifs; default: PSPM motif only")), ToolInput(tag="in_url", input_type=String(optional=True), prefix="-url", doc=InputDocumentation(doc="website for the motif; The motif name is\nsubstituted for MOTIF_NAME; default: no url")), ToolInput(tag="in_no_sort", input_type=Boolean(optional=True), prefix="-nosort", doc=InputDocumentation(doc="don't sort the order of motifs")), ToolInput(tag="in_named", input_type=Boolean(optional=True), prefix="-named", doc=InputDocumentation(doc="looks for a motif name after each IUPAC code;\ndefault: use the IUPAC code as the motif name")), ToolInput(tag="in_add", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_assume", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_default", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_file", input_type=File(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_iupac_motif", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_output", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_use", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_18", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_19", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_frequencies", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_21", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_the", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_total_pseudo_counts", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_with", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_iupac", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_alphabet", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_background", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_based", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_29", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_times", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_definition", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_letter", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_on", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_of", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_this", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_letters", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_many", input_type=String(), position=5, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Iupac2Meme_V0_1_0().translate("wdl", allow_empty_container=True)

